Page MenuHomePhabricator

[mlir][linalg] Use top down traversal for padding.
ClosedPublic

Authored by gysit on Nov 28 2021, 11:28 PM.

Details

Summary

Pad the operation using a top down traversal. The top down traversal unlocks folding opportunities and dim op canonicalizations due to the introduced extract slice operation after the padded operation.

Depends On D114585

Diff Detail

Event Timeline

gysit created this revision.Nov 28 2021, 11:28 PM
gysit requested review of this revision.Nov 28 2021, 11:28 PM
nicolasvasilache accepted this revision.Nov 29 2021, 1:29 AM
This revision is now accepted and ready to land.Nov 29 2021, 1:29 AM
This revision was automatically updated to reflect the committed changes.
mehdi_amini added inline comments.Nov 30 2021, 9:20 PM
mlir/lib/Dialect/Linalg/Transforms/LinalgStrategyPasses.cpp
144

I have concerns about this: the top down / bottom up is supposed, I believe, to be only a crude heuristic and not something used to control the behavior like it is intended here.
The Greedy rewriter is still intended to be a greedy strategy and the comment here has me concerned.

Please revert, unless I misunderstood this change.